﻿using System.Reflection;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 참조 어셈블리 로드하기 - LoadReferencedAssembly(assembly, assemblyLevel)

    /// <summary>
    /// 참조 어셈블리 로드하기
    /// </summary>
    /// <param name="assembly">어셈블리</param>
    /// <param name="assemblyLevel">어셈블리 레벨</param>
    private static void LoadReferencedAssembly(Assembly assembly, int assemblyLevel = 0)
    {
        Console.WriteLine($"{" ".PadRight(assemblyLevel * 4)}{assembly.GetName().Name}");

        foreach(AssemblyName name in assembly.GetReferencedAssemblies())
        {
            if(!AppDomain.CurrentDomain.GetAssemblies().Any(a => a.FullName == name.FullName))
            {
                LoadReferencedAssembly(Assembly.Load(name), assemblyLevel + 1);
            }
        }
    }

    #endregion
    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        foreach(Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
        {
            LoadReferencedAssembly(assembly);
        }
    }

    #endregion
}